﻿Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.Cls_02_DB_Person_Read
Imports NM_Ahnen.Cls_04_Util
Imports NM_Ahnen.Cls_80_Mask_91
Imports NM_Ahnen.Cls_40_Print_Vorfahren
Imports NM_Ahnen.cls_40_Print_Nachfahren
Imports NM_Ahnen
Imports NM_Ahnen.NM_Print

Public Class NM_Print
    Private WithEvents PrintDoc As New System.Drawing.Printing.PrintDocument

    REM ******************************************************************
    REM *  Hauptroutine                                                  *
    REM ******************************************************************
    Private Sub NM_Print_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        PrintDoc.DefaultPageSettings.Landscape = Querformat
        Call Mask_Pos_91()  REM Einbau Maske Print noch erforderlich
        Me.AcceptButton = bt_P_Vorschau

    End Sub

    REM *****************************************************************
    REM *  Abbruch der Funktion                                         *
    REM *****************************************************************
    Private Sub Bt_P_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_P_Cancel.Click
        Me.Close()
    End Sub

    Private Sub Tx_P_ID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_P_ID.TextChanged
        dbl_ID = tx_P_ID.Text
        Call Person_Read_t01_Basis()
        Me.lbl_P_Name.Text = p_str_Name + ", " + p_str_Vorname

    End Sub

    REM *****************************************************************
    REM *  Aufruf der Matchfunktion                                     *
    REM *****************************************************************
    Private Sub Bt_P_Search_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_P_Search.Click
        int_Merk_STyp = 8
        Call Maskenwechsel_Search()
        Me.tx_P_ID.Text = p_int_ID

    End Sub

    REM **************************************************************
    REM *  Aufruf des Druckerdialogs                                 *
    REM **************************************************************
    Private Sub B_P_Print_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_P_Print.Click

        If Me.tx_P_ID.Text = "" Then
            MessageBox.Show("Keine Auswahl getroffen! - Auswählen oder Abbruch")
            Exit Sub
        End If

        If int_Merk_Liste = 1 Then Call Liste_Vorfahren()
        If int_Merk_Liste = 2 Then Call Liste_Nachfahren()
        Me.PrintDialogS.ShowDialog()
        PrintDoc.Print()
        Me.Close()
        NM_Ahnen.Visible = True

    End Sub

    REM **************************************************************
    REM *  Aufruf der Druckvorschau                                  *
    REM **************************************************************
    Private Sub Bt_P_Vorschau_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_P_Vorschau.Click

        If Me.tx_P_ID.Text = "" Then
            MessageBox.Show("Keine Auswahl getroffen! - Auswählen oder Abbruch")
            Exit Sub
        End If

        If int_Merk_Liste = 1 Then Call Liste_Vorfahren()
        If int_Merk_Liste = 2 Then Call Liste_Nachfahren()
        PrintPrev1.PrintPreviewControl.AutoZoom = True
        PrintPrev1.PrintPreviewControl.Zoom = 1.1
        PrintPrev1.AutoSizeMode = Windows.Forms.AutoSizeMode.GrowAndShrink
        PrintPrev1.WindowState = FormWindowState.Maximized
        PrintPrev1.Document = PrintDoc
        response = PrintPrev1.ShowDialog()
        If response = True Then
            PrintDoc.Print()
        End If
        If response = False Then
            Me.Close()
            NM_Ahnen.Visible = True
        End If
    End Sub

    REM ******************************************************************
    REM *  Daten für Liste Vorfahren zusammenstellen                     *
    REM ******************************************************************
    Private Sub Liste_Vorfahren()

        Call Read_Start_Person_Vorfahren()

    End Sub

    REM ******************************************************************
    REM *  Daten für Liste Nachfahren zusammenstellen                    *
    REM ******************************************************************
    Private Sub Liste_Nachfahren()

        Call Read_Start_Person_Nachfahren()

    End Sub

    REM ***********************************************************
    REM *  Dimensionieren und Löschen der Ausgabezeilen           *
    REM ***********************************************************
    Public Shared Sub ClearGenZeilen(ByVal i23 As Integer)

        ReDim Gen_Zeil1(i23)
        ReDim Gen_Zeil2(i23)
        ReDim Gen_Zeil3(i23)
        ReDim Gen_Zeil4(i23)
        ReDim Gen_Zeil5(i23)
        ReDim Gen_Zeil6(i23)
        ReDim Gen_Zeil7(i23)
        ReDim Gen_Zeil8(i23)
        Gen_Zeilen = i23

    End Sub

    REM ****************************************************
    REM *  Print-Dokument Vor- und Nachfahrenliste         *
    REM ****************************************************
    Private Sub PrintDoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) _
                               Handles PrintDoc.PrintPage
        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        e.Graphics.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias

        Dim gr As Graphics = e.Graphics
        Dim l As Integer
        Dim k As Integer
        Dim myFont0 As New Font("Arial", 12)
        Dim myFont3 As New Font("Arial", 10)
        Dim myFont1 As New Font("Arial", 8)
        Dim myFont2 As New Font("Arial", 8, FontStyle.Bold)
        Dim str_SysDat As String = str_AktDatP
        Dim LH0 = myFont3.GetHeight(e.Graphics)
        Dim LH1 = myFont1.GetHeight(e.Graphics)

        Dim pr_LR = e.MarginBounds.Left     ' Linker Rand
        Dim pr_RR = e.MarginBounds.Right    ' Rechter Rand
        Dim pr_OR = e.MarginBounds.Top      ' Oberer Rand (verändert sich variabel bei jeder Druckzeile)
        Dim pr_UR = e.MarginBounds.Bottom   ' Unterer Rand
        Dim pr_NB = pr_RR - pr_LR           ' Nettobreite
        Dim pr_Dt = 20
        Dim pr_Dz = pr_NB / 8
        Dim pr_D1 = pr_LR                       ' Druckposition GenerationsNr
        Dim pr_D2 = pr_LR + pr_Dt               ' Druckposition Verwandtschaftsgrad
        Dim pr_D3 = pr_LR + pr_Dz               ' Druckposition Name
        Dim pr_D4 = pr_NB / 2 + (pr_Dt * 7)     ' Druckposition ID-Person
        Dim pr_D5 = pr_NB / 2 + (pr_Dt * 12)     ' Druckposition ID-Vater
        Dim pr_D6 = pr_NB / 2 + (pr_Dt * 15)     ' Druckposition ID-Mutter
        Dim pr_D7 = pr_NB / 2 + (pr_Dt * 19)    ' Druckposition Geb.datum
        Dim pr_D8 = pr_NB / 2 + (pr_Dt * 24)    ' Druckposition Sterbedatum
        Dim pr_DX = pr_NB / 3
        Dim pr_DP = pr_RR / 3               ' Position Datenausgabe
        Dim pr_MP = pr_RR / 2 + pr_DP       ' Position für Datum/Zeit           
        Dim pr_FP = pr_UR - LH0             ' Position für untere Abschlußzeile
        Dim pr_SP = pr_FP - (LH0 * 2)       ' Positionzeile für Signatur

        Call Print_Kopf()
        Call Print_Fuss()
        Call Spaltenkopf()
        e.HasMorePages = False

        Dim i25 As Integer = -1

        REM *------------------------------------------------------------*
        REM *  Erzeugen der Kopfzeilen                                   *
        REM *------------------------------------------------------------*
        Dim rechteck As New Rectangle(pr_LR, pr_OR, pr_NB, (LH0 * 2))
        gr.FillRectangle(Brushes.LightGray, rechteck)
        pr_OR += LH1
        gr.DrawString(tx_Kopf01, myFont0, Brushes.Black, pr_LR, pr_OR)
        pr_OR += (LH1 * 2)
        gr.DrawString(Gen_Head01, myFont1, Brushes.Black, pr_D1, pr_OR)
        gr.DrawString(Gen_Head02, myFont1, Brushes.Black, pr_D2, pr_OR)
        gr.DrawString(Gen_Head03, myFont1, Brushes.Black, pr_D3, pr_OR)
        gr.DrawString(Gen_Head04, myFont1, Brushes.Black, pr_D4, pr_OR)
        gr.DrawString(Gen_Head05, myFont1, Brushes.Black, pr_D5, pr_OR)
        gr.DrawString(Gen_Head06, myFont1, Brushes.Black, pr_D6, pr_OR)
        gr.DrawString(Gen_Head07, myFont1, Brushes.Black, pr_D7, pr_OR)
        gr.DrawString(Gen_Head08, myFont1, Brushes.Black, pr_D8, pr_OR)

        pr_OR += (LH0 * 2)
        l = Gen_Merk_Zeile + int_NF_Seit_Max
        For k = Gen_Merk_Zeile To l
            REM *------------------------------------------------------------*
            REM *  Erzeugen der Datenzeilen                                  *
            REM *------------------------------------------------------------*
            If k > Gen_Zeilen Then i25 = int_NF_Seit_Max : Exit For
            gr.DrawString(Gen_Zeil1(k), myFont1, Brushes.Black, pr_D1, pr_OR)
            gr.DrawString(Gen_Zeil2(k), myFont1, Brushes.Black, pr_D2, pr_OR)
            gr.DrawString(Gen_Zeil3(k), myFont2, Brushes.Black, pr_D3, pr_OR)
            gr.DrawString(Gen_Zeil4(k), myFont1, Brushes.Black, pr_D4, pr_OR)
            gr.DrawString(Gen_Zeil5(k), myFont1, Brushes.Black, pr_D5, pr_OR)
            gr.DrawString(Gen_Zeil6(k), myFont1, Brushes.Black, pr_D6, pr_OR)
            gr.DrawString(Gen_Zeil7(k), myFont1, Brushes.Black, pr_D7, pr_OR)
            gr.DrawString(Gen_Zeil8(k), myFont1, Brushes.Black, pr_D8, pr_OR)
            pr_OR += LH0
            i25 += 1
            Gen_Merk_Zeile = k + 1

        Next k
        ' Gen_Merk_Zeile = k
        If i25 = int_NF_Seit_Max Then
            REM *------------------------------------------------------------*
            REM *  Erzeugen der Fusszeilen                                   *
            REM *------------------------------------------------------------*
            gr.DrawLine(Pens.Black, pr_LR, pr_FP, pr_RR, pr_FP)
            pr_FP += LH1
            gr.DrawString(tx_Fuss01, myFont1, Brushes.Black, pr_LR, pr_FP)
            gr.DrawString(str_SysDat + " " + TimeString + " Seite: " + (int_Anz_Sub + 1).ToString + "/" + int_Anz_Seit.ToString, myFont1, Brushes.Black, pr_MP, pr_FP)
            'i25 = -1
            int_Anz_Sub += 1
            If Gen_Zeilen > int_NF_Seit_Max Then
                e.HasMorePages = True
            Else
                e.HasMorePages = False
            End If
        Else
            e.HasMorePages = False
        End If

            If int_Anz_Sub = int_Anz_Seit Then
                e.HasMorePages = False
                Exit Sub
            End If

    End Sub

    REM ******************************************************************
    REM *  Definition der Kopfzeilen                                     *
    REM ******************************************************************
    Public Shared Sub Print_Kopf()

        If int_Merk_Liste = 1 Then tx_Kopf01 = "Vorfahrenliste"
        If int_Merk_Liste = 2 Then tx_Kopf01 = "Nachfahrenliste"

    End Sub

    REM ******************************************************************
    REM *  Definition der Fusszeilen                                     *
    REM ******************************************************************
    Public Shared Sub Print_Fuss()

        tx_Fuss01 = str_Prog_Name + " " + str_Prog_Rel + " " + str_Copyright

    End Sub

    REM ********************************************
    REM *  Spaltenköpfe füllen                     *
    REM ********************************************
    Private Sub Spaltenkopf()
        Gen_Head01 = ""
        Gen_Head02 = ""
        Gen_Head03 = ""
        Gen_Head04 = ""
        Gen_Head05 = ""
        Gen_Head06 = ""
        Gen_Head07 = ""
        Gen_Head08 = ""

        If int_Merk_Liste = 1 Then
            Gen_Head01 = "Gen."
            Gen_Head02 = "Verwandt"
            Gen_Head03 = "Name"
            Gen_Head04 = "DB_ID"
            Gen_Head05 = "Kekule"
            Gen_Head07 = "Geb.Dat"
            Gen_Head08 = "St.Dat"
        End If
        If int_Merk_Liste = 2 Then
            Gen_Head01 = "Gen."
            Gen_Head02 = "Verwandt"
            Gen_Head03 = "Name"
            Gen_Head04 = "DB_ID"
            Gen_Head05 = "ID Vater"
            Gen_Head06 = "ID Mutter"
            Gen_Head07 = "Geb.Dat"
            Gen_Head08 = "St.Dat"
        End If
    End Sub

End Class