﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports NM_Ahnen
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.Cls_02_DB_Neu
Imports NM_Ahnen.Cls_05_Strukturen
Imports NM_Ahnen.NM_Ahnen_Search

Class Cls_02_DB

    REM **************************************************************
    REM *  Laden der Ini-Datei (Pfadangabe)                          *
    REM **************************************************************
    Public Shared Sub Load_INI()
        Dim fs As FileStream
        str_NM99 = ""
        str_ini = "NM_Ahnen.ini"
        Try
            fs = New FileStream(str_ini, FileMode.Open)
        Catch ex As IOException
            MsgBox(ex.Message)
            int_Total_Error = 1
            Exit Sub
        End Try

        Dim sw As New StreamReader(fs)
        Dim ze As String
        Dim int_N01 As Integer
        Dim int_N02 As Integer
        Dim int_N03 As Integer
        str_DBPfad1 = ""
        str_DBPfad2 = ""
        str_DBName = ""
        Try
            Do Until sw.Peek() = -1
                ze = sw.ReadLine()
                If Mid(ze, 1, 7) = "[NM01]=" Then str_DBPfad1 = Mid(ze, 8, Len(ze) - 7) : int_N01 = 1
                If Mid(ze, 1, 7) = "[NM02]=" Then
                    str_DBPfad2 = Mid(ze, 8, Len(ze) - 7) : int_N02 = 1
                    str_DBName = Mid(ze, 8, Len(ze) - 7) : int_N03 = 1
                End If
                'If Mid(ze, 1, 7) = "[NM03]=" Then str_DBName = Mid(ze, 8, Len(ze) - 7) : int_N03 = 1
            Loop
            sw.Close()

            str_NM99 = str_DBPfad1 + "\" + str_DBPfad2
            str_Directory = str_NM99
            str_PicDirectory = str_NM99 + "\Pic\"

        Catch ex As Exception
            MsgBox(ex.Message)
            str_ini = ""
        End Try

        If str_DBPfad1 = "" Or str_DBPfad2 = "" Or str_DBName = "" Then
            response = MessageBox.Show("Schwerer Fehler", "DB nicht vorhanden - Neue DB anlegen?", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
            If response = MsgBoxResult.Yes Then
                Call DB_Create()
                Exit Sub
            Else
                Application.Exit()
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Open-Routine für die DB                                   *
    REM **************************************************************
    Public Shared Sub Open_DB()
        If con.State = ConnectionState.Open Then con.Close()
        dbProv = String.Format("Provider=Microsoft.ACE.OLEDB.16.0; Data Source={0}\" + str_DBName + ".accdb; Jet OLEDB:Database Password=NM;", str_NM99)
        con.ConnectionString = dbProv
        mySelect.Connection = con
        mySelect1.Connection = con
        Try
            con.Open()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Beim Öffnen der Datenbank ist ein Fehler aufgetreten.")
            int_Total_Error = 1
        End Try
        NM_Ahnen.Stat_DB.Text = str_DBName
    End Sub

    REM *****************************************************************
    REM *  Laden der Parameterwerte                                     *
    REM *****************************************************************
    Public Shared Sub Open_Para()
        Call Tab_Para()
        Call ID_Tab_Fuell()
        Call ID_TabBeruf_Fuell()
        Call Tab_Datumsart()
        Call Tab_Altersgrenzen()
        Call Tab_Konfessionen()
        Call Tab_Felder()
        Call Tab_Orte()
        Call Tab_Namen()
        Call Tab_Vornamen()
        Call Tab_Tod()
        Call Tab_Beruf()
        Call Tab_Quellen()
        Call DB_Struktur()
        Call Tab_FeldBez()
    End Sub

    REM **************************************************************
    REM *  Füllen der ID-Tabelle für Blätter-Modus                   *
    REM **************************************************************
    Public Shared Sub ID_Tab_Fuell()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Dim int_i5 As Integer = 0
        Dim reader As OleDbDataReader
        int_Ged_Anz = int_Anz
        ReDim lng_ID(int_Anz)

        NM_Ahnen.Stat1_Anzahl.Text = "Anzahl: " & int_Anz.ToString

        mySelect.Connection = con
        mySelect.CommandText = "select * from t01_Person"

        reader = mySelect.ExecuteReader
        Do While reader.Read()
            lng_ID(int_i5) = reader.Item("t01_ID")
            If int_i5 = 0 Then dbl_First_ID = lng_ID(int_i5)
            int_i5 += 1
        Loop
        reader.Close()
        dbl_Max = int_i5
        dbl_Last_ID = lng_ID(int_i5 - 1)
        int_Zeig_Pers = 0
    End Sub

    REM **************************************************************
    REM *  Laden von Basisdaten                                      *
    REM **************************************************************
    Public Shared Sub Tab_Para()
        Dim int_AnzKonf = GetNumberOfRecordsTyp(con, "a00_Para", " where a00_Typ = 1")
        Dim reader As OleDbDataReader
        int_Akt_ID = 0
        int_Screen_x = 0
        int_Screen_y = 0
        mySelect.Connection = con
        mySelect.CommandText = "select * from a00_Para where a00_Typ = 1"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_SubTyp = reader.Item("a00_SubTyp")
            Call Norm_Help()
            myNull = IsDBNull(reader.Item("a00_int1"))
            If myNull = False Then int_P1 = reader.Item("a00_int1")
            myNull = IsDBNull(reader.Item("a00_int2"))
            If myNull = False Then int_P2 = reader.Item("a00_int2")
            myNull = IsDBNull(reader.Item("a00_int3"))
            If myNull = False Then int_P3 = reader.Item("a00_int3")
            myNull = IsDBNull(reader.Item("a00_tx1"))
            If myNull = False Then str_t1 = reader.Item("a00_tx1")
            myNull = IsDBNull(reader.Item("a00_tx2"))
            If myNull = False Then str_t2 = reader.Item("a00_tx2")
            myNull = IsDBNull(reader.Item("a00_tx3"))
            If myNull = False Then str_t3 = reader.Item("a00_tx3")
            If int_SubTyp = 2 Then int_Sprache = int_P1
            If int_SubTyp = 2 Then str_DokPfad = str_t1
            If int_SubTyp = 5 Then int_Akt_ID = int_P1
            If int_SubTyp = 6 Then int_Monitor = int_P1
            If int_SubTyp = 7 Then
                int_Screen_x = int_P1
                int_Screen_y = int_P2
            End If
            If int_SubTyp = 8 Then
                str_Pfad_Pic = str_t1
            End If

        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Datumsarten für Combo-Boxen            *
    REM **************************************************************
    Public Shared Sub Tab_Datumsart()
        int_AnzPara = GetNumberOfRecordsTyp(con, "a00_Para", " where a00_Typ = 5")
        int_High_Datum = int_AnzPara
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 1
        ReDim str_Para_DA(int_AnzPara)
        ReDim int_Para_DA(int_AnzPara)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a00_Para where a00_Typ = 5"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_ID = reader.Item("a00_ID")
            int_i5 = reader.Item("a00_SubTyp")
            Call Norm_Help()
            myNull = IsDBNull(reader.Item("a00_int1"))
            If myNull = False Then int_P1 = reader.Item("a00_int1")
            myNull = IsDBNull(reader.Item("a00_int2"))
            If myNull = False Then int_P2 = reader.Item("a00_int2")
            myNull = IsDBNull(reader.Item("a00_int3"))
            If myNull = False Then int_P3 = reader.Item("a00_int3")
            myNull = IsDBNull(reader.Item("a00_tx1"))
            If myNull = False Then str_t1 = reader.Item("a00_tx1")
            myNull = IsDBNull(reader.Item("a00_tx2"))
            If myNull = False Then str_t2 = reader.Item("a00_tx2")
            myNull = IsDBNull(reader.Item("a00_tx3"))
            If myNull = False Then str_t3 = reader.Item("a00_tx3")
            str_Para_DA(int_i5) = str_t1
            int_Para_DA(int_i5) = int_ID
            scA_Date.Add(str_Para_DA(int_i5))
        Loop
        reader.Close()
        With NM_Ahnen
            .cbx_10_GDat.Items.Clear()
            .cbx_10_SDat.Items.Clear()
            .cbx_11_TDat_Art.Items.Clear()
            .cbx_11_TDat_Art.Items.Clear()
            .cbx_12_BDat_Art.Items.Clear()
            .cbx_13_EDat1_Art.Items.Clear()
            .cbx_13_EDat2_Art.Items.Clear()
            .cbx_13_EDat3_Art.Items.Clear()

            .cbx_10_GDat.Items.Add("")
            .cbx_10_SDat.Items.Add("")
            .cbx_11_TDat_Art.Items.Add("")
            .cbx_11_FDat_Art.Items.Add("")
            .cbx_12_BDat_Art.Items.Add("")
            .cbx_13_EDat1_Art.Items.Add("")
            .cbx_13_EDat2_Art.Items.Add("")
            .cbx_13_EDat3_Art.Items.Add("")

            For int_i5 = 1 To int_AnzPara
                .cbx_10_GDat.Items.Add(str_Para_DA(int_i5))
                .cbx_10_SDat.Items.Add(str_Para_DA(int_i5))
                .cbx_11_TDat_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_11_FDat_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_12_BDat_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_13_EDat1_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_13_EDat2_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_13_EDat3_Art.Items.Add(str_Para_DA(int_i5))
            Next
        End With
    End Sub

    REM **************************************************************
    REM *  Füllen der Felder Pfad                                    *
    REM **************************************************************
    Public Shared Sub Norm_Help()
        int_P1 = 0
        int_P2 = 0
        int_P3 = 0
        str_t1 = ""
        str_t2 = ""
        str_t3 = ""
    End Sub

    REM **************************************************************
    REM *  Füllen der Felder Altersgrenzen                           *
    REM **************************************************************
    Public Shared Sub Tab_Altersgrenzen()
        Dim reader As OleDbDataReader
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a00_Para where a00_Typ = 2"

        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_SubTyp = reader("a00_SubTyp")
            Call Norm_Help()
            myNull = IsDBNull(reader.Item("a00_int1"))
            If myNull = False Then int_P1 = reader.Item("a00_int1")
            myNull = IsDBNull(reader.Item("a00_int2"))
            If myNull = False Then int_P2 = reader.Item("a00_int2")
            myNull = IsDBNull(reader.Item("a00_int3"))
            If myNull = False Then int_P3 = reader.Item("a00_int3")
            myNull = IsDBNull(reader.Item("a00_tx1"))
            If myNull = False Then str_t1 = reader.Item("a00_tx1")
            myNull = IsDBNull(reader.Item("a00_tx2"))
            If myNull = False Then str_t2 = reader.Item("a00_tx2")
            myNull = IsDBNull(reader.Item("a00_tx3"))
            If myNull = False Then str_t3 = reader.Item("a00_tx3")
            If int_SubTyp = 1 Then
                int_Delta_Vater_Min = int_P1
                int_Delta_Vater_Max = int_P2
            End If
            If int_SubTyp = 2 Then
                int_Delta_Mutter_Min = int_P1
                int_Delta_Mutter_Max = int_P2
            End If
            If int_SubTyp = 3 Then
                int_Delta_Ehe_Min = int_P1
                int_Delta_Ehe_Max = int_P2
            End If
            If int_SubTyp = 4 Then
                int_Delta_Pate_Min = int_P1
                int_Delta_Pate_Max = int_P2
            End If
            If int_SubTyp = 5 Then
                int_Delta_Zeuge_Min = int_P1
                int_Delta_Zeuge_Max = int_P2
            End If
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Namen für Combo-Boxen                  *
    REM **************************************************************
    Public Shared Sub Tab_Namen()
        int_AnzNam1 = GetNumberOfRecords(con, "a07_Namen")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Nam1_Text(int_AnzNam1)
        ReDim int_Para_Nam1_Nr(int_AnzNam1)
        ReDim int_Anz_Name(int_AnzNam1, 3)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a07_Namen"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 += 1
            str_Para_Nam1_Text(int_i5) = reader.Item("a07_Text")
            int_Para_Nam1_Nr(int_i5) = int_i5
            int_Anz_Name(int_i5, 0) = reader.Item("a07_Anz0")
            int_Anz_Name(int_i5, 1) = reader.Item("a07_Anz1")
            int_Anz_Name(int_i5, 2) = reader.Item("a07_Anz2")
            int_Anz_Name(int_i5, 3) = reader.Item("a07_Anz3")
            'scA_Nam1.Add(str_Para_Nam1_Text(int_i5))
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Vornamen für Combo-Boxen               *
    REM **************************************************************
    Public Shared Sub Tab_Vornamen()
        int_AnzNam2 = GetNumberOfRecords(con, "a09_Vornamen")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Nam2_Text(int_AnzNam2)
        ReDim int_Para_Nam2_Nr(int_AnzNam2)
        ReDim int_Para_Vorname_Anz(int_AnzNam2)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a09_Vornamen"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 += 1
            str_Para_Nam2_Text(int_i5) = reader.Item("a09_Text")
            myNull = IsDBNull(reader.Item("a09_Anzahl"))
            If myNull = False Then int_Para_Vorname_Anz(int_i5) = reader.Item("a09_Anzahl")
            int_Para_Nam2_Nr(int_i5) = int_i5
            'scA_Nam2.Add(str_Para_Nam2_Text(int_i5))
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Konfessionen für Combo-Boxen           *
    REM **************************************************************
    Public Shared Sub Tab_Konfessionen()
        int_AnzKonf = GetNumberOfRecordsTyp(con, "a00_Para", " where a00_Typ = 3")
        Dim reader As OleDbDataReader
        int_High_Konf = int_AnzKonf
        Dim int_i5 As Integer
        ReDim str_Para_Konf_Bez(int_AnzKonf)
        ReDim str_Para_Konf_Text(int_AnzKonf)
        ReDim int_Para_Konf(int_AnzKonf)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a00_Para where a00_Typ = 3"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_ID = reader.Item("a00_ID")
            int_i5 = reader.Item("a00_SubTyp")
            Call Norm_Help()
            myNull = IsDBNull(reader.Item("a00_int1"))
            If myNull = False Then int_P1 = reader.Item("a00_int1")
            myNull = IsDBNull(reader.Item("a00_int2"))
            If myNull = False Then int_P2 = reader.Item("a00_int2")
            myNull = IsDBNull(reader.Item("a00_int3"))
            If myNull = False Then int_P3 = reader.Item("a00_int3")
            myNull = IsDBNull(reader.Item("a00_tx1"))
            If myNull = False Then str_t1 = reader.Item("a00_tx1")
            myNull = IsDBNull(reader.Item("a00_tx2"))
            If myNull = False Then str_t2 = reader.Item("a00_tx2")
            myNull = IsDBNull(reader.Item("a00_tx3"))
            If myNull = False Then str_t3 = reader.Item("a00_tx3")
            str_Para_Konf_Bez(int_i5) = str_t1
            str_Para_Konf_Text(int_i5) = str_t2
            int_Para_Konf(int_i5) = int_ID
            'scA_Konf.Add(str_Para_Konf_Bez(int_i5))
            NM_Ahnen.cbx_11_Konf.Items.Add(str_Para_Konf_Bez(int_i5))
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Orte für Combo-Boxen                   *
    REM **************************************************************
    Public Shared Sub Tab_Orte()
        int_AnzOrte = GetNumberOfRecordsTyp(con, "a04_Orte", " where a04_Typ = 1")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer
        ReDim str_Para_Ort1_Bez(int_AnzOrte)
        ReDim str_Para_Ort2_Bez(int_AnzOrte)
        ReDim str_Para_Ort3_Bez(int_AnzOrte)
        ReDim str_Para_Ort_Anz0(int_AnzOrte)
        ReDim str_Para_Ort_Anz1(int_AnzOrte)
        ReDim str_Para_Ort_Anz2(int_AnzOrte)
        ReDim str_Para_Ort_Anz3(int_AnzOrte)
        ReDim str_Para_Ort_Anz4(int_AnzOrte)
        ReDim str_Para_Ort_Anz5(int_AnzOrte)
        ReDim str_Para_Ort_Anz6(int_AnzOrte)
        ReDim str_Para_Ort_Anz7(int_AnzOrte)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a04_Orte where a04_Typ = 1"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 = reader.Item("a04_lfd")
            myNull = IsDBNull(reader.Item("a04_Ort1"))
            If myNull = False Then str_Para_Ort1_Bez(int_i5) = reader.Item("a04_Ort1")
            myNull = IsDBNull(reader.Item("a04_Ort2"))
            If myNull = False Then str_Para_Ort2_Bez(int_i5) = reader.Item("a04_Ort2")
            myNull = IsDBNull(reader.Item("a04_Ort3"))
            If myNull = False Then str_Para_Ort3_Bez(int_i5) = reader.Item("a04_Ort3")
            myNull = IsDBNull(reader.Item("a04_Anz0"))
            If myNull = False Then str_Para_Ort_Anz0(int_i5) = reader.Item("a04_Anz0").ToString
            myNull = IsDBNull(reader.Item("a04_Anz1"))
            If myNull = False Then str_Para_Ort_Anz1(int_i5) = reader.Item("a04_Anz1").ToString
            myNull = IsDBNull(reader.Item("a04_Anz2"))
            If myNull = False Then str_Para_Ort_Anz2(int_i5) = reader.Item("a04_Anz2").ToString
            myNull = IsDBNull(reader.Item("a04_Anz3"))
            If myNull = False Then str_Para_Ort_Anz3(int_i5) = reader.Item("a04_Anz3").ToString
            myNull = IsDBNull(reader.Item("a04_Anz4"))
            If myNull = False Then str_Para_Ort_Anz4(int_i5) = reader.Item("a04_Anz4").ToString
            myNull = IsDBNull(reader.Item("a04_Anz5"))
            If myNull = False Then str_Para_Ort_Anz5(int_i5) = reader.Item("a04_Anz5").ToString
            myNull = IsDBNull(reader.Item("a04_Anz6"))
            If myNull = False Then str_Para_Ort_Anz6(int_i5) = reader.Item("a04_Anz6").ToString
            myNull = IsDBNull(reader.Item("a04_Anz7"))
            If myNull = False Then str_Para_Ort_Anz7(int_i5) = reader.Item("a04_Anz7").ToString

            'scA_Orte.Add(str_Para_Ort1_Bez(int_i5))
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Todesarten für Combo-Boxen             *
    REM **************************************************************
    Public Shared Sub Tab_Tod()
        int_AnzTod = GetNumberOfRecords(con, "a08_Tod")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Tod_Text(int_AnzTod)
        ReDim int_Para_Tod_Nr(int_AnzTod)
        ReDim int_Para_Tod_Anz(int_AnzTod)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a08_Tod"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 += 1
            str_Para_Tod_Text(int_i5) = reader.Item("a08_Text")
            myNull = IsDBNull(reader.Item("a08_Anzahl"))
            If myNull = False Then int_Para_Tod_Anz(int_i5) = reader.Item("a08_Anzahl")
            int_Para_Tod_Nr(int_i5) = int_i5
            scA_Tod.Add(str_Para_Tod_Text(int_i5))
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Berufe für Combo-Boxen                 *
    REM **************************************************************
    Public Shared Sub Tab_Beruf()
        int_AnzBeruf = GetNumberOfRecords(con, "a06_Beruf")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Beruf_Text(int_AnzBeruf)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a06_Beruf"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 += 1
            str_Para_Beruf_Text(int_i5) = reader.Item("a06_Beruf")
            scA_Beruf.Add(str_Para_Beruf_Text(int_i5))
        Loop
        reader.Close()
    End Sub
    REM **************************************************************
    REM *  Füllen der Tabelle Quellen für Combo-Boxen                *
    REM **************************************************************
    Public Shared Sub Tab_Quellen()
        Call Fuellen_Quellen_Q1()
        Call Fuellen_Quellen_Q2()
        Call Fuellen_Quellen_Q3()
    End Sub
    Public Shared Sub Fuellen_Quellen_Q1()
        Call DB_Tab_High("t31_ID", "t31_Q1")
        int_AnzQ1 = dbl_Max_ID
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer
        ReDim str_Q1(int_AnzQ1)
        ReDim str_Q1K(int_AnzQ1)
        ReDim int_Q1_Pos(int_AnzQ1)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from t31_Q1"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 = Val(reader.Item("t31_ID"))
            str_Q1(int_i5) = reader.Item("t31_Bezeichnung")
            str_Q1K(int_i5) = reader.Item("t31_Kurz")
            'NM_Ahnen_Quelle.dgv_Q1.items.add(str_Q1(int_i5), str_Q1K(int_i5))
            int_Q1_Pos(int_i5) = int_i5
            NM_Ahnen_Quelle.cbx_t31_Bez.Items.Add(str_Q1(int_i5))
        Loop
        reader.Close()
    End Sub
    Public Shared Sub Fuellen_Quellen_Q2()
        Dim reader As OleDbDataReader
        Call DB_Tab_High("t32_ID", "t32_Q2")
        int_AnzQ2 = dbl_Max_ID
        Dim int_i5 As Integer
        ReDim str_Q2(int_AnzQ2)
        ReDim int_Q2_Typ(int_AnzQ2)
        ReDim int_Q2_Pos(int_AnzQ2)
        mySelect.CommandText = "Select * from t32_Q2"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 = Val(reader.Item("t32_ID"))
            str_Q2(int_i5) = reader.Item("t32_Ort")
            int_Q2_Typ(int_i5) = reader.Item("t32_Typ")
            int_Q2_Pos(int_i5) = int_i5
            NM_Ahnen_Quelle.cbx_t32_Ort.Items.Add(str_Q2(int_i5))
        Loop
        reader.Close()
    End Sub
    Public Shared Sub Fuellen_Quellen_Q3()
        Dim reader As OleDbDataReader
        Call DB_Tab_High("t33_ID", "t33_Q3")
        int_AnzQ3 = dbl_Max_ID
        Dim int_i5 As Integer
        ReDim str_Q3(int_AnzQ3)
        ReDim int_Q3_Pos(int_AnzQ3)
        ReDim int_Q3_Ort(int_AnzQ3)
        mySelect.CommandText = "Select * from t33_Q3"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_i5 = Val(reader.Item("t33_ID"))
            str_Q3(int_i5) = reader.Item("t33_Detail")
            int_Q3_Pos(int_i5) = int_i5
            myNull = IsDBNull(reader.Item("t33_Ort"))
            If myNull = False Then int_P1 = reader.Item("t33_Ort")
            int_Q3_Ort(int_i5) = int_P1
            NM_Ahnen_Quelle.cbx_t33_Detail.Items.Add(str_Q3(int_i5))
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Datumsarten für Combo-Boxen            *
    REM **************************************************************
    Public Shared Sub Tab_Felder()
        int_AnzOrte = GetNumberOfRecordsTyp(con, "a00_Para", " where a00_SubTyp = 2 and a00_int1 = " + int_Sprache.ToString)
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer
        Dim int_i6 As Integer
        ReDim str_FeldBez(8, 20)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a00_Para where a00_int1 = " + int_Sprache.ToString
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            Call Norm_Help()
            myNull = IsDBNull(reader.Item("a00_int1"))
            If myNull = False Then int_P1 = reader.Item("a00_int1")
            myNull = IsDBNull(reader.Item("a00_int2"))
            If myNull = False Then int_P2 = reader.Item("a00_int2")
            myNull = IsDBNull(reader.Item("a00_int3"))
            If myNull = False Then int_P3 = reader.Item("a00_int3")
            myNull = IsDBNull(reader.Item("a00_tx1"))
            If myNull = False Then str_t1 = reader.Item("a00_tx1")
            myNull = IsDBNull(reader.Item("a00_tx2"))
            If myNull = False Then str_t2 = reader.Item("a00_tx2")
            myNull = IsDBNull(reader.Item("a00_tx3"))
            If myNull = False Then str_t3 = reader.Item("a00_tx3")
            int_i5 = int_P1
            int_i6 = int_P2
            str_FeldBez(int_i5, int_i6) = str_t1
        Loop
        reader.Close()
    End Sub
    Public Shared Sub Quellen_Neu()
        Dim reader As OleDbDataReader
        Dim int_t13_Typ As Integer
        Dim dbl_t13() As Double
        Dim str_t13() As String
        Dim int_987 As Integer = 0
        Dim int_Anzt13 As Integer = GetNumberOfRecords(con, "t13_Quelle")
        ReDim dbl_t13(int_Anzt13)
        ReDim str_t13(int_Anzt13)
        NM_Ahnen.Cursor = Cursors.WaitCursor
        mySelect.CommandText = "select * from t13_Quelle"
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    str_QXNeu = ""
                    str_QX1 = ""
                    str_QX2 = ""
                    str_QX3 = ""
                    str_QX4 = ""
                    int_t13_Typ = 0
                    int_t13_Event = 0
                    int_t13_Ort = 0
                    int_t13_Kb = 0
                    dbl_t13_ID = Val(reader.Item("t13_ID"))
                    myNull = IsDBNull(reader.Item("t13_Event"))
                    If myNull = False Then int_t13_Event = Val(reader.Item("t13_Event"))
                    myNull = IsDBNull(reader.Item("t13_Ort"))
                    If myNull = False Then int_t13_Ort = Val(reader.Item("t13_Ort"))
                    myNull = IsDBNull(reader.Item("t13_KB"))
                    If myNull = False Then int_t13_Kb = Val(reader.Item("t13_KB"))
                    myNull = IsDBNull(reader.Item("t13_Detail"))
                    If myNull = False Then str_QX4 = reader.Item("t13_Detail")
                    Call QuellenText()
                    If str_QXNeu > "" Then
                        dbl_t13(int_987) = dbl_t13_ID
                        str_t13(int_987) = str_QXNeu
                        int_987 += 1
                    End If
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        For i988 = 0 To int_987
            dbl_t13_ID = dbl_t13(i988)
            str_QXNeu = str_t13(i988)
            str_Tab = "t13_Quelle = '" + str_QXNeu + "'"
            mySelect.CommandText = "update t13_Quelle set " & str_Tab & " where t13_ID = " & dbl_t13_ID.ToString
            Call DB_Execute()
        Next
        NM_Ahnen.Cursor = Cursors.Default
    End Sub
    Public Shared Sub Quellen_Read()
        Dim reader As OleDbDataReader
        mySelect.CommandText = "select * from t13_Quelle where t13_ID = " & t13_Tab_ID(int_QuellenTyp)
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    myNull = IsDBNull(reader.Item("t13_Event"))
                    If myNull = False Then p_int_Event = Val(reader.Item("t13_Event"))
                    myNull = IsDBNull(reader.Item("t13_Ort"))
                    If myNull = False Then p_int_Ort = Val(reader.Item("t13_Ort"))
                    myNull = IsDBNull(reader.Item("t13_KB"))
                    If myNull = False Then p_int_KB = Val(reader.Item("t13_KB"))
                    myNull = IsDBNull(reader.Item("t13_Detail"))
                    If myNull = False Then p_str_Detail = reader.Item("t13_Detail")
                    myNull = IsDBNull(reader.Item("t13_Datum"))
                    If myNull = False Then p_str_DatQ = reader.Item("t13_Datum")
                    myNull = IsDBNull(reader.Item("t13_Bemerkung"))
                    If myNull = False Then p_str_Bem = reader.Item("t13_Bemerkung")
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    Public Shared Sub Quellen_Update()
        int_t13_Event = int_Sel_t31
        int_t13_Ort = int_Sel_t32
        int_t13_Kb = int_Sel_t33
        Call QuellenText()
        p_str_Quelle(int_QuellenTyp) = str_QXNeu
        str_Tab = "t13_Event = '" + int_t13_Event.ToString + "', "
        str_Tab += "t13_Ort = '" + int_t13_Ort.ToString + "', "
        str_Tab += "t13_KB = '" + int_t13_Kb.ToString + "', "
        str_Tab += "t13_Quelle = '" + str_QXNeu + "', "
        str_Tab += "t13_Datum = '" + str_AktDatP + "'"
        mySelect.CommandText = "update t13_Quelle set " & str_Tab & " where t13_ID = " & t13_Tab_ID(int_QuellenTyp).ToString
        Call DB_Execute()
        NM_Ahnen_Quelle.Close()
    End Sub
    Public Shared Sub Quellen_Insert()
        int_t13_Event = int_Sel_t31
        int_t13_Ort = int_Sel_t32
        int_t13_Kb = int_Sel_t33
        Call QuellenText()
        Call DB_Tab_High("t13_ID", "t13_Quelle")
        dbl_Max_ID += 1
        Dim int_t13_Art As Integer = 1
        If int_Info01 = 13 Then int_t13_Art = 2
        str_DBD_t13 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t13 += "'" + p_int_ID.ToString + "',"
        str_DBD_t13 += "'" + int_t13_Art.ToString + "',"
        str_DBD_t13 += "'" + int_QuellenTyp.ToString + "',"
        str_DBD_t13 += "'" + int_t13_Event.ToString + "',"
        str_DBD_t13 += "'" + int_t13_Ort.ToString + "',"
        str_DBD_t13 += "'" + int_t13_Kb.ToString + "',"
        str_DBD_t13 += "'" + str_QX4 + "',"
        str_DBD_t13 += "'" + str_QXNeu + "',"
        str_DBD_t13 += "'" + NM_Ahnen_Quelle.tx_3x_Datum.Text + "',"
        str_DBD_t13 += "'" + str_Q_Bemerk + "')"
        str_Tab = str_DBS_t13 + str_DBD_t13
        mySelect.CommandText = "insert into t13_Quelle " & str_Tab
        int_Event_OK(int_QuellenTyp) = 1
        p_str_Quelle(int_QuellenTyp) = str_QXNeu
        Call DB_Execute()
        NM_Ahnen_Quelle.Close()
    End Sub

    Public Shared Sub Quellen_Delete()
        response = MessageBox.Show("Sollen die Quellendaten wirklich gelöscht werden ?", "Sicherheitsabfrage", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
        If response = MsgBoxResult.No Then
            NM_Ahnen_Quelle.Close()
            Exit Sub
        End If
        mySelect.CommandText = "delete * from t13_Quelle where t13_ID = " & t13_Tab_ID(int_QuellenTyp).ToString
        Call DB_Execute()
        int_Event_OK(int_QuellenTyp) = 0
        p_str_Quelle(int_QuellenTyp) = ""
        NM_Ahnen_Quelle.Close()
    End Sub

    ' ********************************************************
    ' **  Zusammenbau des Quelltextes                        *
    ' ********************************************************
    Public Shared Sub QuellenText()
        If int_t13_Event > 0 Then
            str_QX1 = str_Q1K(int_t13_Event)
        End If
        If int_t13_KB > 0 Then
            str_QX3 = str_Q3(int_t13_Kb)
        Else
            If int_t13_Event = 1 Then str_QX3 = "?"
        End If
        If int_t13_Ort > 0 Then
            str_QX2 = str_Q2(int_t13_Ort)
        End If
        If str_QX3 > "" Then str_QX1 += " " & str_QX3
        str_QXNeu = str_QX1

        If int_t13_Event = 1 Then
            str_QXNeu += "/" + str_QX4
        Else
            str_QXNeu += " " + str_QX4
        End If
        If str_QX2 > "" Then str_QXNeu += "; " + str_QX2
        Trim(str_QXNeu)
    End Sub

    REM **************************************************************
    REM *  Füllen der Berufe-Tabelle                                 *
    REM **************************************************************
    Public Shared Sub ID_TabBeruf_Fuell()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "a06_Beruf")
        Dim int_i5 As Integer = 0
        Dim reader As OleDbDataReader
        ReDim tab_Beruf_ID(int_Anz)
        ReDim tab_Beruf_Bez(int_Anz)
        mySelect.Connection = con
        mySelect.CommandText = "Select * from a06_Beruf"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            tab_Beruf_ID(int_i5) = reader.Item("a06_ID")
            tab_Beruf_Bez(int_i5) = reader.Item("a06_Beruf")
            int_i5 += 1
        Loop
        reader.Close()
        dbl_Beruf_Max = int_i5
    End Sub

    REM ******************************************************************
    REM *  Function Select count(*)                                      *
    REM ******************************************************************
    Public Shared Function GetNumberOfRecords(ByVal cnn As OleDbConnection, ByVal TableName As String) As Integer
        Dim cmd As New OleDbCommand("Select count(*) from " & TableName, cnn)
        Dim ret As Object = cmd.ExecuteScalar
        If ret IsNot Nothing Then
            Return CType(ret, Integer)
        Else
            Return 0
        End If
    End Function

    REM ******************************************************************
    REM *  Function Select count(*) und Where-Bedingung                  *
    REM ******************************************************************
    Public Shared Function GetNumberOfRecordsTyp(ByVal cnn As OleDbConnection, ByVal TableName As String, ByVal where As String) As Integer
        Dim cmd As New OleDbCommand("Select count(*) from " & TableName & where, cnn)
        Dim ret As Object = cmd.ExecuteScalar
        If ret IsNot Nothing Then
            Return CType(ret, Integer)
        Else
            Return 0
        End If
    End Function

    REM ******************************************************************
    REM *  Select auf T01 (höchste ID)                                   *
    REM ******************************************************************
    Public Shared Sub DB_Tab_High(ByVal str_ID As String, ByVal str_TX As String)
        mySelect.Connection = con
        mySelect.CommandText = "Select MAX(" + str_ID + ") from " + str_TX
        myAdapter.SelectCommand = mySelect
        Try
            dbl_Max_ID = mySelect.ExecuteScalar
        Catch ex As Exception
            dbl_Max_ID = 0
        End Try
    End Sub

    REM ******************************************************************
    REM *  Select auf T01 (höchste laufende Nr von ID)                   *
    REM ******************************************************************
    Public Shared Sub DB_T99_LFD_High()
        mySelect.Connection = con
        mySelect.CommandText = "Select MAX(t99_LFD) from t99_Aufgabe where t99_FK_t01 = " + dbl_Max_ID.ToString
        myAdapter.SelectCommand = mySelect
        Try
            int_Max_LFD = mySelect.ExecuteScalar
        Catch ex As Exception
            int_Max_LFD = 0
        End Try
    End Sub

    REM ******************************************************************
    REM *  Gesamtselect auf einzelne Tabelle und Daten                   *
    REM *  im Grid anzeigen                                              *
    REM ******************************************************************
    Public Shared Sub DB_Sel_All()
        Dim reader As OleDbDataReader
        Dim i1 As Integer
        Dim x_str_DatTT As String = ""
        Dim x_str_DatMM As String = ""
        Dim x_str_DatJJ As String = ""

        NM_Ahnen_Search.dgv_91_Tab.ClearSelection()
        REM *------------------------------------------------------------*
        REM *  Anpassung, wenn phonetische Suche gesetzt                 *
        REM *------------------------------------------------------------*
        'If int_Merk_Phon = 1 Then str_Search2 = "%" + str_Search1 & "%'"
        REM *------------------------------------------------------------*
        REM *  Ermitteln der Trefferzahl                                 *
        REM *------------------------------------------------------------*
        mySelect.Connection = con
        mySelect.CommandText = "select count(*) from t01_Person " & str_Where
        int_Anz = GetNumberOfRecordsTyp(con, "t01_Person", str_Where)
        str_Sel_Anz = " / Selektiert: " + int_Anz.ToString
        NM_Ahnen_Search.Text = str_Search_Header + str_Sel_Anz
        REM *------------------------------------------------------------*
        REM *  Prüfen auf Trefferzahl                                    *
        REM *------------------------------------------------------------*
        If int_Anz = 0 Then
            MsgBox("Keine Treffer!")
            int_Total_Error = 1
            int_Merk_First = 0
            Exit Sub
        End If
        REM *------------------------------------------------------------*
        REM *  Temporär-Tabelle dimensionieren und löschen               *
        REM *------------------------------------------------------------*
        ReDim temp_ID(int_Anz)
        ReDim x_int_ID(int_Anz)
        ReDim x_str_Name(int_Anz)
        ReDim x_str_GName(int_Anz)
        ReDim x_str_VName(int_Anz)
        ReDim x_str_GDat(int_Anz)
        ReDim x_str_SDat(int_Anz)
        ReDim x_str_GOrt(int_Anz)
        ReDim x_str_SOrt(int_Anz)
        ReDim x_str_GSort(int_Anz)
        ReDim x_str_SSort(int_Anz)

        REM *------------------------------------------------------------*
        REM *  Select-Commando zusammensetzen                            *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t01_Person " & str_Where & ""
        reader = mySelect.ExecuteReader
        i1 = 0
        REM *------------------------------------------------------------*
        REM *  Gefülltes Reader-Objekt zeilenweise abarbeiten und        *
        REM *  Temp-Tabelle füllen                                       *
        REM *------------------------------------------------------------*

        Do While reader.Read()
            myNull = IsDBNull(reader.Item("t01_Id"))
            If myNull = False Then x_int_ID(i1) = reader.Item("t01_Id")
            myNull = IsDBNull(reader.Item("t01_Name"))
            If myNull = False Then x_str_Name(i1) = reader.Item("t01_Name")
            myNull = IsDBNull(reader.Item("t01_GebName"))
            If myNull = False Then x_str_GName(i1) = reader.Item("t01_GebName")
            myNull = IsDBNull(reader.Item("t01_Vorname"))
            If myNull = False Then x_str_VName(i1) = reader.Item("t01_Vorname")
            myNull = IsDBNull(reader.Item("t01_GDat_TT"))
            If myNull = False Then x_str_DatTT = reader.Item("t01_GDat_TT")
            myNull = IsDBNull(reader.Item("t01_GDat_MM"))
            If myNull = False Then x_str_DatMM = reader.Item("t01_GDat_MM")
            myNull = IsDBNull(reader.Item("t01_GDat_JJ"))
            If myNull = False Then x_str_DatJJ = reader.Item("t01_GDat_JJ")
            x_str_GDat(i1) = x_str_DatTT + "." + x_str_DatMM + "." + x_str_DatJJ
            myNull = IsDBNull(reader.Item("t01_GOrt"))
            If myNull = False Then x_str_GOrt(i1) = reader.Item("t01_GOrt")
            myNull = IsDBNull(reader.Item("t01_SDat_TT"))
            If myNull = False Then x_str_DatTT = reader.Item("t01_SDat_TT")
            myNull = IsDBNull(reader.Item("t01_SDat_MM"))
            If myNull = False Then x_str_DatMM = reader.Item("t01_SDat_MM")
            myNull = IsDBNull(reader.Item("t01_SDat_JJ"))
            If myNull = False Then x_str_DatJJ = reader.Item("t01_SDat_JJ")
            x_str_SDat(i1) = x_str_DatTT + "." + x_str_DatMM + "." + x_str_DatJJ
            myNull = IsDBNull(reader.Item("t01_SOrt"))
            If myNull = False Then x_str_SOrt(i1) = reader.Item("t01_SOrt")
            myNull = IsDBNull(reader.Item("t01_GDat_Sort"))
            If myNull = False Then x_str_GSort(i1) = reader.Item("t01_GDat_Sort")
            myNull = IsDBNull(reader.Item("t01_SDat_Sort"))
            If myNull = False Then x_str_SSort(i1) = reader.Item("t01_SDat_Sort")
            i1 += 1
        Loop
                dbl_Tmp = i1 - 1
        REM *------------------------------------------------------------*
        REM *  Evtl. Anpassen des Selektionsergebnisses                  *
        REM *------------------------------------------------------------*
        reader.Close()
DB_Sel_All_900:
        int_Merk_First = 0
        Call DB_Tab_All()
    End Sub

    REM ******************************************************************
    REM *  Gesamtselect auf einzelne Tabelle und Daten                   *
    REM *  im Grid anzeigen                                              *
    REM ******************************************************************
    Public Shared Sub DB_Tab_All()
        If int_Merk_First = 0 Then Call DB_Tab_First()
        int_Merk_Tab = 1
    End Sub

    REM ******************************************************************
    REM *  DB-Operation bei erstmaliger Grid-Anzeige                     *
    REM ******************************************************************
    Public Shared Sub DB_Tab_First()
        dbl_PosS = 0
        'End If
        For i1 = 0 To dbl_Tmp
            With NM_Ahnen_Search.dgv_91_Tab
                .Rows.Add(x_int_ID(i1).ToString("###0"), x_str_Name(i1), x_str_GName(i1), x_str_VName(i1), x_str_GDat(i1), x_str_GOrt(i1), x_str_SDat(i1), x_str_SOrt(i1), x_str_GSort(i1), x_str_SSort(i1))
            End With
        Next
        int_Merk_First = 1
        Call GridSpalten()
    End Sub

    Public Shared Sub Parameter_Save()
        ' speichern letzte ID
        int_P1 = Val(NM_Ahnen.tx_00_ID.Text)
        int_ID = 5
        Call Para00_Update(1)
        ' speichern Monitorgröße
        int_P1 = int_Monitor
        int_ID = 6
        Call Para00_Update(1)
        'speichern Screen-Location
        int_P1 = NM_Ahnen.Location.X
        int_P2 = NM_Ahnen.Location.Y
        int_ID = 7
        Call Para00_Update(1)
        Call Para00_Update(2)
    End Sub

    Public Shared Sub Para00_Update(ByVal int_F As Integer)
        If int_F = 1 Then str_Tab = "a00_int1 = '" + int_P1.ToString + "'"
        If int_F = 2 Then str_Tab = "a00_int2 = '" + int_P2.ToString + "'"
        If int_F = 3 Then str_Tab = "a00_int3 = '" + int_P3.ToString + "'"
        If int_F = 4 Then str_Tab = "a00_tx1 = '" + str_t1 + "'"
        If int_F = 5 Then str_Tab = "a00_tx2 = '" + str_t2 + "'"
        If int_F = 6 Then str_Tab = "a00_tx3 = '" + str_t3 + "'"
        mySelect.CommandText = "update a00_Para set " & str_Tab & " where a00_ID = " & int_ID.ToString
        Call DB_Execute()
        NM_Ahnen_Para.grp_Ort_Neu.Visible = False
        NM_Ahnen_Para.bt_201_OK.Visible = False
    End Sub

    REM ******************************************************************
    REM *  DB-transaction Execute                                        *
    REM ******************************************************************
    Public Shared Sub DB_Execute()
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            If int_Merk_Import = 0 Then
                MsgBox(ex.Message & mySelect.CommandText)
            Else
                Using sw As StreamWriter = File.AppendText(str_LogFile)
                    sw.WriteLine(GM_Nr + "/ " + ex.Message)
                End Using
            End If
        End Try
    End Sub

End Class
