﻿Option Explicit On
Option Strict Off
Imports System.Data.OleDb
Imports System.IO
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.Cls_02_DB_Person_Read
Imports NM_Ahnen
Imports NM_Ahnen.NM_Print

Public Class Cls_40_Print_Nachfahren
    Private WithEvents PrintDoc As New System.Drawing.Printing.PrintDocument
    'PrintDoc.DefaultPageSettings.Landscape = Querformat

    Public Shared Sub Nachfahren()
        int_Merk_Liste = 2
        NM_Print.Show()
    End Sub

    REM ***************************************************************************
    REM *  Daten der Startperson laden                                            *
    REM ***************************************************************************
    Public Shared Sub Read_Start_Person_Nachfahren()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Gen_NF_High = int_Anz + 1
        GenZ12 = int_Anz
        GenZ11 = GenZ12 / 2
        GenZ10 = GenZ11
        GenZ09 = GenZ10
        GenZ08 = GenZ09
        GenZ07 = GenZ08
        GenZ06 = GenZ07
        GenZ05 = GenZ06

        Gen_Nach_Max = 20
        Gen_Lg = 5
        REM *  Dimensionieren der Hilfstabellen
        ReDim Gen_15(GenZ12, 2)
        ReDim Gen_14(GenZ12, 2)
        ReDim Gen_12(GenZ12, 2)
        ReDim Gen_11(GenZ11, 2)
        ReDim Gen_10(GenZ10, 2)
        ReDim Gen_09(GenZ09, 2)
        ReDim Gen_08(GenZ08, 2)
        ReDim Gen_07(GenZ07, 2)
        ReDim Gen_06(GenZ06, 2)
        ReDim Gen_05(GenZ05, 2)
        ReDim Gen_04(GenZ05, 2)
        ReDim Gen_03(GenZ05, 2)
        ReDim Gen_02(GenZ05, 2)
        ReDim Gen_01(GenZ05, 2)
        GenZ15 = 1
        GenZ14 = 1
        GenZ13 = 1
        GenZ12 = 1
        GenZ11 = 1
        GenZ10 = 1
        GenZ09 = 1
        GenZ08 = 1
        GenZ07 = 1
        GenZ06 = 1
        GenZ05 = 1
        GenZ04 = 1
        GenZ03 = 1
        GenZ02 = 1
        GenZ01 = 1

        ReDim Gen_NF(int_Anz, Gen_Nach_Max)
        ReDim Gen_AltID(Gen_Nach_Max)
        ReDim Gen_ID(Gen_NF_High)
        ReDim Gen_XStufe(Gen_NF_High)
        ReDim Gen_StufID(Gen_NF_High)
        ReDim Gen_Str(Gen_NF_High)
        REM *  Startwerte setzen
        Gen_Tab_Read = 0
        Gen_Kek = 1
        Gen_Stuf = 0
        Gen_XStuf = 0
        Gen_SP = 1
        Gen_STZ = 1
        int_T5 = 0

        dbl_ID = NM_Print.tx_P_ID.Text
        REM *  Daten der Startperson lesen
        Gen_ID(0) = dbl_ID
        Gen_StufID(0) = dbl_ID
        Gen_Str(0) = "00000" + dbl_ID.ToString("00000") + "00" + dbl_ID.ToString("00000") + "00"
        int_GenZ = 1
        Gen_NF(0, 0) = dbl_ID   REM Startperson wird auf 0,0 fixiert
        int_T1 = -1
        Call Read_Kinder()
        Call Nachfahren_Tab_Read()
        Call Tab_Nachfahren_Aufbau()
    End Sub

    REM *****************************************************
    REM *  Die Daten der Nachfahren lesen und einfügen      *
    REM *****************************************************
    Public Shared Sub Nachfahren_Tab_Read()
        Dim i63 As Integer
Tab_Read_Start:

        ReDim Gen_AltID(Gen_Nach_Max)
        If Gen_Tab_Read > int_T1 Then
            Exit Sub
        End If
        int_T3 = Gen_Tab_Read
        For i63 = Gen_SP To Gen_Nach_Max
            If Gen_NF(int_T3, i63) = 0 Then
                Gen_Tab_Read += 1
                Gen_SP = 1
                GoTo Tab_Read_Start
            Else
                dbl_ID = Gen_NF(int_T3, i63)
                Gen_SP = i63 + 1
                Call Read_Kinder()
            End If
        Next
    End Sub
    REM ***************************************************
    REM *  Lesen der Kindsdaten aus Rollenfunktion 3      *
    REM ***************************************************
    Public Shared Sub Read_Kinder()
        Dim reader As OleDbDataReader
        int_T2 = 0
        Dim int_Find As Integer = 0
        Dim int_Pers As Long
        str_Where = " where t05_FK_t01 = " + dbl_ID.ToString + " and t05_Typ = 3"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where
        ReDim Gen_Alt1(Gen_Nach_Max)
        For i66 = 0 To Gen_Nach_Max
            Gen_Alt1(i66) = "999999"
        Next
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Gen_Kind = 0
                int_Find = 1
                int_T1 += 1
                ReDim Gen_AltID(Gen_Nach_Max)
                If Gen_Kek = 0 Then
                    Gen_NF(int_T1, int_T2) = dbl_ID
                    Call Nachfahren_Clear()
                Else
                    Gen_Kek = 0
                End If
                Call Stufe_Ermitteln()

                Do While reader.Read()
                    int_Pers = reader.Item("t05_FK_Rolle")
                    int_T2 += 1
                    int_T5 += 1
                    Gen_AltID(int_T2) = int_Pers
                    Gen_StufID(int_T5) = int_Pers
                    Gen_XStufe(int_T5) = Gen_XStuf
                    Gen_STZ += 1
                    Gen_Kind += 1
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        If int_Find = 1 Then Call Nachfahren_Sort()

    End Sub

    Public Shared Sub Nachfahren_Clear()
        Dim iz As Integer
        For iz = 1 To Gen_Nach_Max
            Gen_NF(int_T1, iz) = 0
        Next
    End Sub

    ' **********************************************************
    ' *  Ermitteln der Verwandtenstufe                         *
    ' **********************************************************
    Public Shared Sub Stufe_Ermitteln()
        Dim i71 As Integer
        For i71 = 0 To Gen_STZ
            If dbl_ID = Gen_StufID(i71) Then
                Gen_XStuf = Gen_XStufe(i71)
                Exit For
            End If
        Next
        Gen_XStuf += 1
    End Sub
    REM *********************************************************
    REM *  Sortieren der Kinderzeile in Altersfolge             *
    REM *********************************************************
    Public Shared Sub Nachfahren_Sort()
        Dim PNR As Integer
        Dim GEN_GDat As String
        Dim Gen_J1 As Integer
        Dim Gen_M1 As Integer
        For i62 = 1 To Gen_Kind
            If Gen_AltID(i62) > 0 Then
                dbl_ID = Gen_AltID(i62)
                Call Person_Read_t01_Basis()
                Gen_J1 = Val(p_str_GDat_JJ)
                Gen_M1 = Val(p_str_GDat_MM)
                GEN_GDat = Gen_J1.ToString("0000") + Gen_M1.ToString("00")
                Gen_Alt1(i62) = GEN_GDat + dbl_ID.ToString("00000")
            End If
        Next
        Array.Sort(Gen_Alt1)
        Dim i70 As Integer = 1
        For i62 = 0 To (Gen_Kind - 1)
            PNR = Val(Mid(Gen_Alt1(i62), 7, 5))
            Gen_NF(int_T1, i70) = PNR
            i70 += 1
        Next
    End Sub
    REM ***************************************************
    REM Hilfstabellen füllen                              *
    REM ***************************************************
    Public Shared Sub Tab_Nachfahren_Aufbau()
        Dim iTab As Integer = 0
        Dim iTx As Integer = 0
        Dim iSt As Integer
        Dim int_PersX As Integer

        'str_LogFile = str_Directory + "/NF_Prot" + str_AktDat1 + ".txt"
        'Using sw As StreamWriter = File.CreateText(str_LogFile)
        '    sw.WriteLine("Aufbau Nachfahren")
        '    sw.WriteLine("Startzeit: " + DateTime.Now)
        'End Using
        ReDim Gen_x1(Gen_NF_High)
        ReDim Gen_x2(Gen_NF_High)

        For i65 = 0 To int_T1
            For i66 = 1 To Gen_Nach_Max
                Gen_x1(iTab) = Gen_NF(i65, 0)
                Gen_x2(iTab) = Gen_NF(i65, i66)
                If Gen_NF(i65, i66) = 0 Then Exit For

                dbl_ID = Gen_x2(iTab)
                Call Stufe_Ermitteln()
                iSt = Gen_XStuf - 1
                If iSt = 1 Then Call GenTab01(iTab)
                If iSt = 2 Then Call GenTab02(iTab)
                If iSt = 3 Then Call GenTab03(iTab)
                If iSt = 4 Then Call GenTab04(iTab)
                If iSt = 5 Then Call GenTab05(iTab)
                If iSt = 6 Then Call GenTab06(iTab)
                If iSt = 7 Then Call GenTab07(iTab)
                If iSt = 8 Then Call GenTab08(iTab)
                If iSt = 9 Then Call GenTab09(iTab)
                If iSt = 10 Then Call GenTab10(iTab)
                If iSt = 11 Then Call GenTab11(iTab)
                If iSt = 12 Then Call GenTab12(iTab)
                If iSt = 13 Then Call GenTab13(iTab)
                If iSt = 14 Then Call GenTab14(iTab)
                If iSt = 15 Then Call GenTab15(iTab)
                int_GenZ += 1
                iTx += 1
            Next
            iTab += 1
        Next
        ReDim Gen_x1(Gen_NF_High)
        ReDim Gen_x2(Gen_NF_High)
        ' *** Startperson in Tabelle übernehmen Platz 0
        int_GenZ = 0
        int_PersX = Gen_NF(0, 0)
        Call Stufen_Start()
        Call Tab_Insert(int_PersX, 0)
        For i65 = 0 To int_T1
            For i66 = 1 To Gen_Nach_Max
                Gen_x1(iTab) = Gen_NF(i65, 0)
                Gen_x2(iTab) = Gen_NF(i65, i66)
                If Gen_NF(i65, i66) = 0 Then Exit For

                dbl_ID = Gen_x2(iTab)
                int_PersX = dbl_ID
                Call Stufen_Start()
                Call Stufe_Ermitteln()
                iSt = Gen_XStuf - 1
                If iSt = 1 Then Call ReadTab_01()
                If iSt = 2 Then Call ReadTab_02()
                If iSt = 3 Then Call ReadTab_03()
                If iSt = 4 Then Call ReadTab_04()
                If iSt = 5 Then Call ReadTab_05()
                If iSt = 6 Then Call ReadTab_06()
                If iSt = 7 Then Call ReadTab_07()
                If iSt = 8 Then Call ReadTab_08()
                If iSt = 9 Then Call ReadTab_09()
                If iSt = 10 Then Call ReadTab_10()
                If iSt = 11 Then Call ReadTab_11()
                If iSt = 12 Then Call ReadTab_12()
                If iSt = 13 Then Call ReadTab_13()
                If iSt = 14 Then Call ReadTab_14()
                If iSt = 15 Then Call ReadTab_15()
                Call Tab_Insert(int_PersX, iSt)
            Next
        Next

        ReDim Gen_Str1(int_GenZ - 1)
        For i = 0 To int_GenZ - 1
            Gen_Str1(i) = Gen_Str(i)
        Next
        Array.Sort(Gen_Str1)
        Call Nachfahren_Tab_Insert(int_GenZ)
    End Sub
    ' *********************************************************
    ' *  Tabellensatz für Sort füllen                         *
    ' *********************************************************
    Public Shared Sub Tab_Insert(ByVal int_P_Nr As Integer, iStx As Integer)
        Dim str_Satz As String
        str_Satz = int_ST1.ToString("000") + int_ST2.ToString("000") + int_ST3.ToString("000") + int_ST4.ToString("000") + int_ST5.ToString("000") + int_ST6.ToString("000") + int_ST7.ToString("000")
        str_Satz += int_ST8.ToString("000") + int_ST9.ToString("000") + int_ST10.ToString("000") + int_ST11.ToString("000") + int_ST12.ToString("000")
        str_Satz += int_ST13.ToString("000") + int_ST14.ToString("000") + int_ST15.ToString("000")
        str_Satz += int_P_Nr.ToString("00000") + iStx.ToString("00")
        Gen_Str(int_GenZ) = str_Satz
        int_GenZ += 1
    End Sub
    Public Shared Sub Stufen_Start()
        int_ST1 = 0
        int_ST2 = 0
        int_ST3 = 0
        int_ST4 = 0
        int_ST5 = 0
        int_ST6 = 0
        int_ST7 = 0
        int_ST8 = 0
        int_ST9 = 0
        int_ST10 = 0
        int_ST11 = 0
        int_ST12 = 0
        int_ST13 = 0
        int_ST14 = 0
        int_ST15 = 0
    End Sub

    ''*********************************************************
    ' *  Generationstabellen füllen                           *
    ' *********************************************************
    Public Shared Sub GenTab01(ByVal iZ As Integer)
        Gen_01(GenZ01, 1) = Gen_x1(iZ)
        Gen_01(GenZ01, 2) = Gen_x2(iZ)
        GenZ01 += 1
    End Sub
    Public Shared Sub GenTab02(ByVal iZ As Integer)
        Gen_02(GenZ02, 1) = Gen_x1(iZ)
        Gen_02(GenZ02, 2) = Gen_x2(iZ)
        GenZ02 += 1
    End Sub
    Public Shared Sub GenTab03(ByVal iZ As Integer)
        Gen_03(GenZ03, 1) = Gen_x1(iZ)
        Gen_03(GenZ03, 2) = Gen_x2(iZ)
        GenZ03 += 1
    End Sub
    Public Shared Sub GenTab04(ByVal iZ As Integer)
        Gen_04(GenZ04, 1) = Gen_x1(iZ)
        Gen_04(GenZ04, 2) = Gen_x2(iZ)
        GenZ04 += 1
    End Sub
    Public Shared Sub GenTab05(ByVal iZ As Integer)
        Gen_05(GenZ05, 1) = Gen_x1(iZ)
        Gen_05(GenZ05, 2) = Gen_x2(iZ)
        GenZ05 += 1
    End Sub
    Public Shared Sub GenTab06(ByVal iZ As Integer)
        Gen_06(GenZ06, 1) = Gen_x1(iZ)
        Gen_06(GenZ06, 2) = Gen_x2(iZ)
        GenZ06 += 1
    End Sub
    Public Shared Sub GenTab07(ByVal iZ As Integer)
        Gen_07(GenZ07, 1) = Gen_x1(iZ)
        Gen_07(GenZ07, 2) = Gen_x2(iZ)
        GenZ07 += 1
    End Sub
    Public Shared Sub GenTab08(ByVal iZ As Integer)
        Gen_08(GenZ08, 1) = Gen_x1(iZ)
        Gen_08(GenZ08, 2) = Gen_x2(iZ)
        GenZ08 += 1
    End Sub
    Public Shared Sub GenTab09(ByVal iZ As Integer)
        Gen_09(GenZ09, 1) = Gen_x1(iZ)
        Gen_09(GenZ09, 2) = Gen_x2(iZ)
        GenZ09 += 1
    End Sub
    Public Shared Sub GenTab10(ByVal iZ As Integer)
        Gen_10(GenZ10, 1) = Gen_x1(iZ)
        Gen_10(GenZ10, 2) = Gen_x2(iZ)
        GenZ10 += 1
    End Sub
    Public Shared Sub GenTab11(ByVal iZ As Integer)
        Gen_11(GenZ11, 1) = Gen_x1(iZ)
        Gen_11(GenZ11, 2) = Gen_x2(iZ)
        GenZ11 += 1
    End Sub
    Public Shared Sub GenTab12(ByVal iZ As Integer)
        Gen_12(GenZ12, 1) = Gen_x1(iZ)
        Gen_12(GenZ12, 2) = Gen_x2(iZ)
        GenZ12 += 1
    End Sub
    Public Shared Sub GenTab13(ByVal iZ As Integer)
        Gen_13(GenZ13, 1) = Gen_x1(iZ)
        Gen_13(GenZ13, 2) = Gen_x2(iZ)
        GenZ13 += 1
    End Sub
    Public Shared Sub GenTab14(ByVal iZ As Integer)
        Gen_14(GenZ14, 1) = Gen_x1(iZ)
        Gen_14(GenZ14, 2) = Gen_x2(iZ)
        GenZ14 += 1
    End Sub
    Public Shared Sub GenTab15(ByVal iZ As Integer)
        Gen_15(GenZ15, 1) = Gen_x1(iZ)
        Gen_15(GenZ15, 2) = Gen_x2(iZ)
        GenZ15 += 1
    End Sub
    ' *******************************************************
    ' *  Rückwärtsermittlung der Generationen               *
    ' *  immer ausgehend von der Generationsstufe abwärts   *
    ' *******************************************************
    Public Shared Sub ReadTab_01()
        For i = 0 To GenZ01 - 1
            If Gen_01(i, 2) = dbl_ID Then
                dbl_ID = Gen_01(i, 1)
                int_ST1 = i
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_02()
        For i = 0 To GenZ02 - 1
            If Gen_02(i, 2) = dbl_ID Then
                dbl_ID = Gen_02(i, 1)
                int_ST2 = i
                Call ReadTab_01()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_03()
        For i = 0 To GenZ03 - 1
            If Gen_03(i, 2) = dbl_ID Then
                dbl_ID = Gen_03(i, 1)
                int_ST3 = i
                Call ReadTab_02()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_04()
        For i = 0 To GenZ04 - 1
            If Gen_04(i, 2) = dbl_ID Then
                dbl_ID = Gen_04(i, 1)
                int_ST4 = i
                Call ReadTab_03()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_05()
        For i = 0 To GenZ05 - 1
            If Gen_05(i, 2) = dbl_ID Then
                dbl_ID = Gen_05(i, 1)
                int_ST5 = i
                Call ReadTab_04()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_06()
        For i = 0 To GenZ06 - 1
            If Gen_06(i, 2) = dbl_ID Then
                dbl_ID = Gen_06(i, 1)
                int_ST6 = i
                Call ReadTab_05()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_07()
        For i = 0 To GenZ07 - 1
            If Gen_07(i, 2) = dbl_ID Then
                dbl_ID = Gen_07(i, 1)
                int_ST7 = i
                Call ReadTab_06()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_08()
        For i = 0 To GenZ08 - 1
            If Gen_08(i, 2) = dbl_ID Then
                dbl_ID = Gen_08(i, 1)
                int_ST8 = i
                Call ReadTab_07()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_09()
        For i = 0 To GenZ09 - 1
            If Gen_09(i, 2) = dbl_ID Then
                dbl_ID = Gen_09(i, 1)
                int_ST9 = i
                Call ReadTab_08()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_10()
        For i = 0 To GenZ10 - 1
            If Gen_10(i, 2) = dbl_ID Then
                dbl_ID = Gen_10(i, 1)
                int_ST10 = i
                Call ReadTab_09()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_11()
        For i = 0 To GenZ11 - 1
            If Gen_11(i, 2) = dbl_ID Then
                dbl_ID = Gen_11(i, 1)
                int_ST11 = i
                Call ReadTab_10()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_12()
        For i = 0 To GenZ12 - 1
            If Gen_12(i, 2) = dbl_ID Then
                dbl_ID = Gen_12(i, 1)
                int_ST12 = i
                Call ReadTab_11()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_13()
        For i = 0 To GenZ13 - 1
            If Gen_13(i, 2) = dbl_ID Then
                dbl_ID = Gen_13(i, 1)
                int_ST13 = i
                Call ReadTab_12()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_14()
        For i = 0 To GenZ14 - 1
            If Gen_14(i, 2) = dbl_ID Then
                dbl_ID = Gen_14(i, 1)
                int_ST14 = i
                Call ReadTab_13()
                Exit For
            End If
        Next
    End Sub
    Public Shared Sub ReadTab_15()
        For i = 0 To GenZ15 - 1
            If Gen_15(i, 2) = dbl_ID Then
                dbl_ID = Gen_15(i, 1)
                int_ST15 = i
                Call ReadTab_14()
                Exit For
            End If
        Next
    End Sub

    REM ***************************************************
    REM *  Einfügen der notwendigen Daten in Hilfstabelle *
    REM ***************************************************
    Public Shared Sub Nachfahren_Tab_Insert(ByVal i23 As Integer)
        Call ClearGenZeilen(i23)
        For i24 = 0 To i23 - 1
            dbl_ID = Mid(Gen_Str1(i24), 46, 5)
            Gen_Stuf = Mid(Gen_Str1(i24), 51, 2)
            Gen_Zeil1(i24) = (Gen_Stuf).ToString("##0") + " "
            Call V_GradN(Gen_Stuf)
            Gen_Zeil2(i24) = Gen_Grad

            If Gen_Stuf > 0 Then
                For l = 1 To Gen_Stuf
                    Gen_Zeil3(i24) = Gen_Zeil3(i24) + "."
                Next
            End If
            Gen_Zeil3(i24) = Gen_Zeil3(i24) + p_str_Name
            If p_str_GebName <> p_str_Name Then Gen_Zeil3(i24) += ", geb. " + p_str_GebName
            Gen_Zeil3(i24) += ", " + p_str_Vorname

            Gen_Zeil4(i24) = dbl_ID.ToString("####0")
            Gen_Zeil5(i24) = p_int_Vater.ToString("####0")
            Gen_Zeil6(i24) = p_int_Mutter.ToString("####0")
            Gen_Zeil7(i24) = "*" + p_str_GDat_TT + "." + p_str_GDat_MM + "." + p_str_GDat_JJ
            Gen_Zeil8(i24) = "+" + p_str_SDat_TT + "." + p_str_SDat_MM + "." + p_str_SDat_JJ
        Next
        int_Anz_Seit = Gen_Zeilen / int_NF_Seit_Max
        dbl_Anz_Seit = int_Anz_Seit + int_NF_Seit_Max
        'If dbl_Anz_Seit < Gen_Zeilen Then int_Anz_Seit += 1
        int_Anz_Sub = 0
        Gen_Merk_Zeile = 0

    End Sub

    Public Shared Sub V_GradN(ByVal i25 As Integer)
        Gen_Grad = ""
        If i25 = 0 Then Gen_Grad = "Proband"
        If i25 = 1 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Sohn"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Tochter"
        End If
        If i25 = 2 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Enkel"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Enkelin"
        End If
        If i25 = 3 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Urenkel"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Urenkelin"
        End If
        If i25 > 3 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Ur(" + (i25 - 2).ToString + ")enkel"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Ur(" + (i25 - 2).ToString + ")enkelin"
        End If
    End Sub

End Class
