﻿Option Explicit On
Option Strict Off
Imports System.IO
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_80_Mask_91
Imports NM_Ahnen.cls_30_Search
Imports NM_Ahnen
Imports NM_Ahnen.NM_Ahnen_Search
Imports NM_Ahnen.NM_Print

Public Class Cls_40_Print_Vorfahren

    Private WithEvents PrintDoc As New System.Drawing.Printing.PrintDocument
    'PrintDoc.DefaultPageSettings.Landscape = Querformat

    REM *******************************************************
    REM *  Ermitteln der Startperson
    REM *  Generationszähler auf Null stellen
    REM *  Tabelleninsertzähler = 0
    REM *  Daten in Tabelle eintragen (PersonenNr., Generation, Elternnr. KekuleNr.
    REM *  Tabellenlesezähler = Null

    REM *  Startpunkt 1
    REM *  Dazulesen der Eltern (Vater, wenn vorhanden)
    REM *  Generationszähler erhöhen
    REM *  KekuleNr. ermitteln
    REM *  Tabelleninsertzähler um 1 erhöhen
    REM *  Daten in Tabelle eintragen (s.o.)

    REM *  Dazulesen der Eltern (Mutter, wenn vorhanden)
    REM *  Generationszähler erhöhen
    REM *  KekuleNr. ermitteln
    REM *  Tabelleninsertzähler um 1 erhöhen
    REM *  Daten in Tabelle eintragen (s.o.)

    REM *  Tabellenlesezähler um 1 erhöhen
    REM *  Weiter bei Startpunkt 1

    Public Shared Sub Vorfahren()
        int_Merk_Liste = 1
        NM_Print.Show()

    End Sub

    REM ***************************************************************************
    REM *  Daten der Startperson laden                                            *
    REM ***************************************************************************
    Public Shared Sub Read_Start_Person_Vorfahren()

        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Gen_NF_High = int_Anz - 1
        Dim i66 As Integer

        REM *  Dimensionieren der Hilfstabellen
        ReDim Gen_ID(int_Anz)
        ReDim Gen_Kekule(int_Anz)
        ReDim Gen_Mutter(int_Anz)
        ReDim Gen_Stufe(int_Anz)
        ReDim Gen_Vater(int_Anz)

        For i66 = 0 To int_Anz
            Gen_ID(i66) = 0
            Gen_Kekule(i66) = 0
            Gen_Mutter(i66) = 0
            Gen_Vater(i66) = 0
            Gen_Stufe(i66) = 0
        Next i66

        REM *  Startwerte setzen
        Gen_Tab_Ins = 0
        Gen_Tab_Read = 0
        Gen_Kek = 1
        Gen_Stuf = 0

        dbl_ID = NM_Print.tx_P_ID.Text

        REM *  Daten der Startperson lesen
        Call Person_Read_t01_Basis()
        NM_Print.lbl_P_Name.Text = p_str_Name + ", " + p_str_Vorname

        REM *  Daten in Hilfstabellen einfügen
        Call Vorfahren_Tab_Insert()
        Call Vorfahren_Tab_Read()
        Call Vorfahren_Tab92()

    End Sub

    REM ***************************************************
    REM *  Einfügen der notwendigen Daten in Hilfstabelle *
    REM ***************************************************
    Public Shared Sub Vorfahren_Tab_Insert()
        Gen_ID(Gen_Tab_Ins) = dbl_ID
        Gen_Kekule(Gen_Tab_Ins) = Gen_Kek
        Gen_Vater(Gen_Tab_Ins) = p_int_Vater
        Gen_Mutter(Gen_Tab_Ins) = p_int_Mutter
        Gen_Stufe(Gen_Tab_Ins) = Gen_Stuf
    End Sub

    REM *****************************************************
    REM *  Die Daten der Vorfahren lesen und einfügen       *
    REM *****************************************************
    Public Shared Sub Vorfahren_Tab_Read()

Read_Tab_Next:

        If Gen_Vater(Gen_Tab_Read) > 0 Then
            dbl_ID = Gen_Vater(Gen_Tab_Read)
            Call Person_Read_t01_Basis()
            Gen_Tab_Ins += 1
            Gen_Kek = Gen_Kekule(Gen_Tab_Read) * 2
            Gen_Stuf = Gen_Stufe(Gen_Tab_Read) + 1
            Call Vorfahren_Tab_Insert()
        End If

        If Gen_Mutter(Gen_Tab_Read) > 0 Then
            dbl_ID = Gen_Mutter(Gen_Tab_Read)
            Call Person_Read_t01_Basis()
            Gen_Tab_Ins += 1
            Gen_Kek = Gen_Kekule(Gen_Tab_Read) * 2 + 1
            Gen_Stuf = Gen_Stufe(Gen_Tab_Read) + 1
            Call Vorfahren_Tab_Insert()
        End If

        REM *  Wenn keine Vorfahren mehr gefunden werden, Ende der Sub_Prozedur
        REM *  andernfalls weiterlesen aufgrund von Einträgen in Hilfstabelle
        If Gen_Tab_Ins <= Gen_Tab_Read Then
            Exit Sub
        End If

        Gen_Tab_Read += 1
        GoTo Read_Tab_Next

    End Sub

    REM **************************************************************
    REM *  Hilfstabellen abarbeiten und DB-Tabelle 92 erstellen      *
    REM **************************************************************
    Public Shared Sub Vorfahren_Tab92()

        Dim dbl_I1 As Double = 0

        REM *------------------------------------------------------------*
        REM *  Zusammenbau des Selectstrings für Inputdaten              *
        REM *------------------------------------------------------------*

        REM *--------------------------------------------------------*
        REM *  Datensatz lesen                                       *
        REM *--------------------------------------------------------*
        dbl_ID = Gen_ID(dbl_I1)
        Call Person_Read_t01_Basis()

        REM *--------------------------------------------------------*
        REM *  Datensatz für Workdatei zusammensetzen                *
        REM *--------------------------------------------------------*
        Call ClearGenZeilen(Gen_Tab_Ins)
        For i24 = 0 To Gen_Tab_Ins

            dbl_ID = Gen_ID(i24)
            Call Person_Read_t01_Basis()
            Gen_Zeil1(i24) = Gen_Stufe(i24).ToString("##0") + " "
            Call VGradV(Gen_Stufe(i24))
            Gen_Zeil2(i24) = Gen_Grad

            If Gen_Stufe(i24) > 0 Then
                For l = 1 To Gen_Stufe(i24)
                    Gen_Zeil3(i24) = Gen_Zeil3(i24) + "."
                Next
            End If
            Gen_Zeil3(i24) = Gen_Zeil3(i24) + p_str_Name
            If p_str_GebName <> p_str_Name Then Gen_Zeil3(i24) += ", geb. " + p_str_GebName
            Gen_Zeil3(i24) += ", " + p_str_Vorname

            Gen_Zeil4(i24) = dbl_ID.ToString("####0")
            Gen_Zeil5(i24) = Gen_Kekule(i24).ToString("####0")
            'Gen_Zeil6(i24) = p_int_Mutter.ToString("####0")
            Gen_Zeil7(i24) = "*" + p_str_GDat_TT + "." + p_str_GDat_MM + "." + p_str_GDat_JJ
            Gen_Zeil8(i24) = "+" + p_str_SDat_TT + "." + p_str_SDat_MM + "." + p_str_SDat_JJ
        Next

        int_Anz_Seit = Gen_Zeilen / int_NF_Seit_Max
        dbl_Anz_Seit = int_Anz_Seit + int_NF_Seit_Max
        If dbl_Anz_Seit < Gen_Zeilen Then int_Anz_Seit += 1
        int_Anz_Sub = 0
        Gen_Merk_Zeile = 0

    End Sub

    REM ******************************************************************
    REM *  Ermitteln Verwandtschaftsgrad                                 *
    REM ******************************************************************
    Public Shared Sub VGradV(ByVal int_V As Integer)

        Gen_Grad = ""
        If int_V = 0 Then Gen_Grad = "Proband"
        If int_V = 1 Then Gen_Grad = "Eltern"
        If int_V = 2 Then Gen_Grad = "Großeltern"
        If int_V = 3 Then Gen_Grad = "Urgroßeltern"
        If int_V > 3 Then Gen_Grad = "Ur(" + (int_V - 2).ToString + ")großeltern"

    End Sub

End Class

