﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen.NM_Ahnen_DB
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.Cls_09_Mask_Person

Public Class Cls_60_Info

    REM **************************************************************
    REM *  Lesen des InfoTextes                                      *
    REM **************************************************************
    Public Shared Sub Read_Info_01(ByVal int_x1 As Integer, int_x2 As Integer)

        Dim reader1 As OleDbDataReader
        int_Merk_info = 1
        p_akt_Komm = ""
        int_Info01 = int_x1
        int_Info02 = int_x2
        If str_InfoTyp = "A" Then
            str_Where = " where t11_FK_t01 = " + dbl_ID.ToString
            str_Where += " and t11_Typ = " + int_x1.ToString
            str_Where += " and t11_Nummer = " + int_x2.ToString
            mySelect.Connection = con

            REM *--------------------------------------------------------*
            REM *  Prüfen, ob Info bereits vorhanden                     *
            REM *--------------------------------------------------------*
            int_Anz_Komm = GetNumberOfRecordsTyp(con, "t11_Kommentar", str_Where)
            mySelect1.CommandText = "select * from t11_Kommentar" & str_Where

            If int_Anz_Komm = 1 Then
                Try
                    reader1 = mySelect1.ExecuteReader
                    Do While reader1.Read()
                        myNull = IsDBNull(reader1.Item("t11_Text"))
                        If myNull = False Then p_akt_Komm = reader1.Item("t11_Text")
                    Loop
                    reader1.Close()
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try
            Else
                REM *----------------------------------------------------*
                REM *  kein Info vorhanden, dann Neuanlagemodus          *
                REM *----------------------------------------------------*
                With NM_Ahnen
                    NM_Ahnen_Komm.rbt_Komm_Text.Text = ""
                    str_InfoTyp = "N"
                End With
            End If
        End If
        With NM_Ahnen
            NM_Ahnen_Komm.Text = "Hinweis " + str_Info01
            NM_Ahnen_Komm.rbt_Komm_Text.Text = p_akt_Komm
        End With
        Call Info_Button()
        Call Maskenwechsel_Komm()
    End Sub

    REM *************************************************************
    REM *  Hinweistextfeld Button sichtbar machen                   *
    REM *************************************************************
    Public Shared Sub Info_Button()
        With NM_Ahnen
            NM_Ahnen_Komm.bt_Komm_OK.Visible = True
            NM_Ahnen_Komm.bt_Komm_Cancel.Visible = True
            NM_Ahnen_Komm.bt_Komm_Del.Visible = True
            NM_Ahnen_Komm.rbt_Komm_Text.Focus()
        End With
    End Sub

    REM *************************************************************
    REM *  Steuerung der Info-Anlage                                *
    REM *************************************************************
    Public Shared Sub Info_Anlegen()
        p_akt_Komm = NM_Ahnen_Komm.rbt_Komm_Text.Text
        If str_InfoTyp = "N" Then
            Call Info_Anlegen_Neu_t11()
            Call Info_Anlegen_Neu_t10()
        End If
        If str_InfoTyp = "A" Then
            Call Info_Anlegen_Update()
        End If
        Call Aktuell_Info()
    End Sub

    REM *************************************************************
    REM *  Einen neuen Infosatz anlegen                             *
    REM *************************************************************
    Public Shared Sub Info_Anlegen_Neu_t11()
        REM *-------------------------------------------------------*
        REM *  Nächste freie ID für Kommentar ermitteln             *
        REM *-------------------------------------------------------*
        Call DB_Tab_High("t11_ID", "t11_Kommentar")
        dbl_Max_ID += 1
        REM *-------------------------------------------------------*
        REM *  Datenstruktur für Kommentar füllen                   *
        REM *  Datensatz inserten                                   *
        REM *-------------------------------------------------------*
        str_DBD_t11 = " values ('" + dbl_Max_ID.ToString + "', '"
        str_DBD_t11 += dbl_ID.ToString + "', '"
        str_DBD_t11 += int_Info01.ToString + "', '"
        str_DBD_t11 += int_Info02.ToString + "', '"
        str_DBD_t11 += p_akt_Komm + "')"
        str_Tab = str_DBS_t11 + str_DBD_t11
        mySelect.Connection = con
        mySelect.CommandText = "insert into t11_Kommentar " & str_Tab
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM *************************************************************
    REM *  Einen neuen Infosatz anlegen                             *
    REM *************************************************************
    Public Shared Sub Info_Anlegen_Neu_t10()
        Dim i1 As Integer
        REM *-------------------------------------------------------*
        REM *  Kommentarnummern aktualisieren                       *
        REM *-------------------------------------------------------*
        str_Where = " where t10_ID = " + dbl_ID.ToString
        mySelect.Connection = con
        int_Anz_Komm = GetNumberOfRecordsTyp(con, "t10_KommNr", str_Where)
        REM *-------------------------------------------------------*
        REM *  Neuanlage der Nummernsatzes                          *
        REM *-------------------------------------------------------*
        If int_Anz_Komm = 0 Then
            str_DBD_t10 = "values ('"
            str_DBD_t10 += dbl_ID.ToString + "', "
            For i1 = 1 To 65
                If i1 = int_Info02 Then
                    str_DBD_t10 += "'1'"
                Else
                    str_DBD_t10 += "'0'"
                End If
                If i1 < 50 Then
                    str_DBD_t10 += ", "
                Else
                    str_DBD_t10 += ") "
                End If
            Next
            str_Tab = str_DBS_t10 + str_DBD_t10
            mySelect.Connection = con
            mySelect.CommandText = "insert into t10_KommNr " & str_Tab
            Try
                DB_Anz = mySelect.ExecuteNonQuery
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        End If
        REM *-------------------------------------------------------*
        REM *  Updaten der Nummernsatzes                            *
        REM *-------------------------------------------------------*
        If int_Anz_Komm = 1 Then
            Call Info_Nummer_Update(1)
        End If
        Call Aktuell_Info()
    End Sub

    REM *************************************************************
    REM *  einen bestehenden Infosatz erweitern                     *
    REM *************************************************************
    Public Shared Sub Info_Anlegen_Update()

        str_Where = " where t11_FK_t01 = " + dbl_ID.ToString
        str_Where += " and t11_Typ = " + int_Info01.ToString
        str_Where += " and t11_Nummer = " + int_Info02.ToString
        mySelect.Connection = con

        str_Tab = "t11_Text = '" + p_akt_Komm + "' "
        mySelect.CommandText = "update t11_Kommentar set " & str_Tab & str_Where
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        Call Aktuell_Info()
    End Sub

    REM *************************************************************
    REM *  Hinweistextfeld löschen                                  *
    REM *************************************************************
    Public Shared Sub Info_Loeschen()
        REM *-------------------------------------------------------*
        REM *  Sicherheitsabfrage                                   *
        REM *-------------------------------------------------------*
        Dim str_Msg As String = "Soll ein Kommentar wirklich gelöscht werden "
        Dim style As MsgBoxStyle = MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
        Dim result As MsgBoxResult
        result = MsgBox(str_Msg, style, str_Info01)
        REM *-------------------------------------------------------*
        REM *  Abbruch der Löschung                                 *
        REM *-------------------------------------------------------*
        If result = MsgBoxResult.No Then
            Exit Sub
        End If
        REM *-------------------------------------------------------*
        REM *  Löschung soll erfolgen                               *
        REM *-------------------------------------------------------*
        If result = MsgBoxResult.Yes Then
            REM *---------------------------------------------------*
            REM *  Texteintrag in Tabelle t10 löschen               *
            REM *---------------------------------------------------*
            str_Where = " where t11_FK_t01 = " + dbl_ID.ToString
            str_Where += " and t11_Typ = " + int_Info01.ToString
            str_Where += " and t11_Nummer = " + int_Info02.ToString
            mySelect.Connection = con
            mySelect.CommandText = "delete * from t11_Kommentar" & str_Where
            Try
                DB_Anz = mySelect.ExecuteNonQuery
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
            Call Info_Nummer_Update(0)
        End If

        Call Aktuell_Info()
    End Sub

    REM **************************************************************
    REM *  Updaten der Kommentarnummer                               *
    REM **************************************************************
    Public Shared Sub Info_Nummer_Update(ByVal int_Wert As Integer)
        str_Tab = "set t10_Komm" + int_Info02.ToString("00") + " = " + int_Wert.ToString
        mySelect.Connection = con
        mySelect.CommandText = "update t10_KommNr " & str_Tab & " where t10_ID = " & dbl_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


    REM **************************************************************
    REM *  Aktualisieren der Kommentaranzeige                        *
    REM **************************************************************
    Public Shared Sub Aktuell_Info()
        Call Mask_Clear_Komm()
        Call Person_Komm_Nr()
        Call Mask_Out_Komm()
        Call Mask_Out_Komm_Ehe()
    End Sub
End Class
